<?php

function set_cookie($name, $value = '', $expire = 0, $path = '/', $domain = '', $secure = false){
	$currentDomain = preg_replace('/(^www\.|:\d+$)/', '', (!empty($_SERVER["HTTP_HOST"]) && $_SERVER["HTTP_HOST"]!=$_SERVER['SERVER_NAME'])?$_SERVER["HTTP_HOST"]:$_SERVER['SERVER_NAME']);
	if (!preg_match('/(?:\d{1,3}\.){3}\d{1,3}/', $currentDomain) && $currentDomain != 'localhost'){
		$domain = '.'.$currentDomain;
	}
		
	setcookie($name, $value, $expire, $path, $domain, $secure);	
}

?>