<?php

error_reporting(0);

if(!isset($_POST['a']) or !isset($_POST['vs']))die;

include "connect.php";
$config = $sql->select(array('table' => 'config','where' => array('id=1')));

include 'helpers/check.php';
$check = checkup();

include 'helpers/time.php'; 

if($_POST['a'] == 'syn'){

	$parse_d = explode("::",$_POST['dStr']);
	$user_time = mktime($parse_d[0],0,0,$parse_d[1] + 1,$parse_d[2],$parse_d[3]);
	$server_time = mktime(date('H'),0,0,date('n'),date('j'),date('Y'));

	$offset = ($user_time - $server_time) / 3600;

	if($config[0]['offset'] != $offset)
		$sql->update(array('table' => 'config', 'values' => array('offset' => $offset), 'where' => array('id=1')));

	echo $offset;
}

$js = <<<DATA
	var previousPoint = null;
	$("#placeholder").bind("plothover", function (event, pos, item) { 
       
		if (item) {
			if (previousPoint != item.datapoint) {
				previousPoint = item.datapoint;
                    
                    		$("#tooltip").remove();

				var x = item.datapoint[0].toFixed(2),
				y = item.datapoint[1];
                    
				showTooltip(item.pageX, item.pageY, item.series.label + ": " + y);
                	}
		}
		else {
			$("#tooltip").remove();
			previousPoint = null;            
            	}
	});
DATA;

if($_POST['a'] == 'vis-pastday'){
	$data = $sql->select(array('table' => 'hits', 'where' => array('type=h')));

	$visits['h'] = array();
	foreach($data as $row){
		$visits['h'][$row['time']] = $row;
	}

	$hour = get_time('hour');

	$_1 = ''; $_2 = ''; $_3 = '';

	for ($i=23; $i>=0; $i--){
		$j = $hour - ($i*60*60);

		if (isset($visits['h'][$j])){
			$h = $visits['h'][$j]['visits']; $uh = $visits['h'][$j]['unique'];
		} else {
			$h = '0'; $uh = '0';
		}

		$_1 .= '['.(23-$i).','.$h.']'.($i !=0 ? ',' : '');
		$_2 .= '['.(23-$i).','.$uh.']'.($i !=0 ? ',' : '');
		$_3 .= '['.(23-$i).',"'.($i % 2 == 0 ? date('H',$j).':00' : '').'"]'.($i !=0 ? ',' : '');
	}

$return = <<<D
$(function () {
	var d1 = [$_1];
	var d2 = [$_2];

	$.plot($("#placeholder"), [{
			data : d1, color : '#000099', shadowSize: 3, label : "Pageviews"
		}, {
			data : d2, color : '#009900', shadowSize: 3, label : "Unique Visitors"
		}], 

		{ xaxis: { ticks: [$_3] }, yaxis: { min : 0 },

		selection: { mode: "xy" },
		grid: { hoverable: true },
		lines: { show: true },
		points: { show: true }
	});

	$js

});
D;

echo $return;

}



if($_POST['a'] == 'vis-pastweek'){
	$data = $sql->select(array('table' => 'hits', 'where' => array('type=d')));

	$visits['d'] = array();
	foreach($data as $row){
		$visits['d'][$row['time']] = $row;
	}

	$day = get_time('day');

	$_1 = ''; $_2 = ''; $_3 = '';

	for ($i=6; $i>=0; $i--){
		$j = $day - ($i*60*60*24);

		if (isset($visits['d'][$j])){
			$d = $visits['d'][$j]['visits']; $ud = $visits['d'][$j]['unique'];
		} else {
			$d = '-'; $ud = '-';
		}

		$weekday = $i ==0 ? 'Today' :  date('l',$j);

		if (isset($visits['d'][$j])){
			$d = $visits['d'][$j]['visits']; $ud = $visits['d'][$j]['unique'];
		} else {
			$d = '0'; $ud = '0';
		}

		$_1 .= '['.(6-$i).','.$d.']'.($i !=0 ? ',' : '');
		$_2 .= '['.(6-$i).','.$ud.']'.($i !=0 ? ',' : '');
		$_3 .= '['.(6-$i).',"'.$weekday.'"]'.($i !=0 ? ',' : '');
	}

$return = <<<D
$(function () {
	var d1 = [$_1];
	var d2 = [$_2];

	$.plot($("#placeholder"), [{
			data : d1, color : '#000099', shadowSize: 3, label : "Pageviews"
		}, {
			data : d2, color : '#009900', shadowSize: 3, label : "Unique Visitors"
		}], 

		{ xaxis: { ticks: [$_3] }, yaxis: { min : 0 },

		selection: { mode: "xy" },
		grid: { hoverable: true },
		lines: { show: true },
		points: { show: true }
	});

	$js

});
D;

echo $return;

}


if($_POST['a'] == 'vis-pastmonth'){
	$data = $sql->select(array('table' => 'hits', 'where' => array('type=w')));

	$visits['w'] = array();
	foreach($data as $row){
		$visits['w'][$row['time']] = $row;
	}

	$week = get_time('week');

	$_1 = ''; $_2 = ''; $_3 = '';

	for ($i=4; $i>=0; $i--){
		$j = $week - ($i*60*60*24*7);

		if($i == 0)
			$wago = 'This Week';
		if($i == 1)
			$wago = 'Last Week';
		if($i == 2)
			$wago = '2 weeks ago';
		if($i == 3)
			$wago = '3 weeks ago';
		if($i == 4)
			$wago = '4 weeks ago';

		if (isset($visits['w'][$j])){
			$w = $visits['w'][$j]['visits']; $uw = $visits['w'][$j]['unique'];
		} else {
			$w = '0'; $uw = '0';
		}

		$_1 .= '['.(4-$i).','.$w.']'.($i !=0 ? ',' : '');
		$_2 .= '['.(4-$i).','.$uw.']'.($i !=0 ? ',' : '');
		$_3 .= '['.(4-$i).',"'.$wago.'"]'.($i !=0 ? ',' : '');
	}

$return = <<<D
$(function () {
	var d1 = [$_1];
	var d2 = [$_2];

	$.plot($("#placeholder"), [{
			data : d1, color : '#000099', shadowSize: 3, label : "Pageviews"
		}, {
			data : d2, color : '#009900', shadowSize: 3, label : "Unique Visitors"
		}], 

		{ xaxis: { ticks: [$_3] }, yaxis: { min : 0 },

		selection: { mode: "xy" },
		grid: { hoverable: true },
		lines: { show: true },
		points: { show: true }
	});

	$js

});
D;

echo $return;

}



if($_POST['a'] == 'vis-pastyear'){
	$data = $sql->select(array('table' => 'hits', 'where' => array('type=m')));

	$visits['m'] = array();
	foreach($data as $row){
		$visits['m'][$row['time']] = $row;
	}

	$month = get_time('month');

	$_1 = ''; $_2 = ''; $_3 = '';

	for ($i=0; $i<12; $i++){

		if ($i==0){ $j=$month; }
		else {
			$days = offsetDate('t', offsetMakeGMT(0, 0, 0, offsetDate('n', $month)-1, 1, offsetDate('Y', $month)));
			$j = $month - ($days*24*3600);
		}

		$month = $j;

		if (isset($visits['m'][$j])){
			$m = $visits['m'][$j]['visits']; $um = $visits['m'][$j]['unique'];
		} else {
			$m = '0'; $um = '0';
		}

		$array['m'][] = $m;
		$array['um'][] = $um;
		$array['j'][] = $j;

	}

	for ($i=0; $i<12; $i++){
		$_1 .= '['.($i).','.$array['m'][11-$i].']'.($i !=11 ? ',' : '');
		$_2 .= '['.($i).','.$array['um'][11-$i].']'.($i !=11 ? ',' : '');
		$_3 .= '['.($i).',"'.date('M`y',$array['j'][11-$i]).'"]'.($i !=11 ? ',' : '');
	}


$return = <<<D
$(function () {
	var d1 = [$_1];
	var d2 = [$_2];

	$.plot($("#placeholder"), [{
			data : d1, color : '#000099', shadowSize: 3, label : "Pageviews"
		}, {
			data : d2, color : '#009900', shadowSize: 3, label : "Unique Visitors"
		}], 

		{ xaxis: { ticks: [$_3] }, yaxis: { min : 0 },

		selection: { mode: "xy" },
		grid: { hoverable: true },
		lines: { show: true },
		points: { show: true }
	});

	$js

});
D;

echo $return; 

}



if($_POST['a'] == 'vis-overview'){

	echo '<table cellpadding=0 cellspacing=0 border=0 width=100% class="visitors"><tr><td width=50% valign=top>
	<table cellpadding=0 cellspacing=0 class="block" border=0 width=100%><thead>
	<tr style="background: #eee;">
	<td width=70><nobr>&nbsp; <b>Past day</b></nobr></td><td align=right>Pageviews</td><td align=right>Unique</td></tr></thead>
	<tbody>';

	$data = $sql->select(array('table' => 'hits', 'where' => array('type=h')));

	$visits['h'] = array();
	foreach($data as $row){
		$visits['h'][$row['time']] = $row;
	}

	$hour = get_time('hour');

	for ($i=0; $i<24; $i++){
		$j = $hour - ($i*60*60);

		if (isset($visits['h'][$j]))
			{
				$h = $visits['h'][$j]['visits'];
				$uh = $visits['h'][$j]['unique'];
			}
			else
			{
				$h = '-';
				$uh = '-';
			}
		
		echo '<tr>
		<td align=right class="date">', date('H:i',$j), '</td><td align=right>', $h, '</td><td align=right>'.$uh.'</td></tr>';
	}

	echo '</tbody></table>';

	echo '<table cellpadding=0 cellspacing=0 class="block" border=0 width=100%><thead>
	<tr style="background: #eee;">
	<td width=70 style="border-left: solid 1px #fff;"><nobr>&nbsp; <b>Since</b></nobr></td>
	<td align=right>Pageviews</td><td align=right>Unique</td></tr></thead>
	<tbody>';

	$data = $sql->select(array('table' => 'hits', 'where' => array('type=all')));

	if(isset($data[0])){
		$since = $data[0]['time'];
		$allv = $data[0]['visits'];
		$alluv = $data[0]['unique'];
	}
	else{
		$since = time();
		$allv = '-';
		$alluv = '-';
	}
		
	echo '<tr>
	<td align=right class="date">', date('M`y',$j), '</td><td align=right>', $allv, '</td><td align=right>'.$alluv.'</td></tr>';
	

	echo '</tbody></table>';

	echo '</td><td width=50% valign="top" style="border-left: solid 1px #ededed">
	<table cellpadding=0 cellspacing=0 class="block" border=0 width=100%><thead>
	<tr style="background: #eee;">
	<td width=80 style="border-left: solid 1px #fff;"><nobr>&nbsp; <b>Past week</b></nobr></td>
	<td align=right>Pageviews</td><td align=right>Unique</td></tr></thead>
	<tbody>';
		
	$data = $sql->select(array('table' => 'hits', 'where' => array('type=d')));

	$visits['d'] = array();
	foreach($data as $row){
		$visits['d'][$row['time']] = $row;
	}

	$day = get_time('day');

	for ($i=0; $i<7; $i++){
		$j = $day - ($i*60*60*24);

		if (isset($visits['d'][$j]))
			{
				$d = $visits['d'][$j]['visits'];
				$ud = $visits['d'][$j]['unique'];
			}
			else
			{
				$d = '-';
				$ud = '-';
			}

		$weekday = $i ==0 ? 'Today' :  date('l',$j);
		
		echo '<tr>
		<td align=right class="date">', $weekday, '</td><td align=right>', $d, '</td><td align=right>'.$ud.'</td></tr>';
	}

	echo '</tbody></table>';
	echo '<table cellpadding=0 cellspacing=0 class="block" border=0 width=100%><thead>
	<tr style="background: #eee;">
	<td width=80 style="border-left: solid 1px #fff;"><nobr>&nbsp; <b>Past month</b></nobr></td>
	<td align=right>Pageviews</td><td align=right>Unique</td></tr></thead>
	<tbody>';
	
	$data = $sql->select(array('table' => 'hits', 'where' => array('type=w')));

	$visits['w'] = array();
	foreach($data as $row){
		$visits['w'][$row['time']] = $row;
	}

	$week = get_time('week');

	for ($i=0; $i<5; $i++){
		$j = $week - ($i*60*60*24*7);

		if($i == 0)
			$wago = 'This Week';
		if($i == 1)
			$wago = 'Last Week';
		if($i == 2)
			$wago = '2 weeks ago';
		if($i == 3)
			$wago = '3 weeks ago';
		if($i == 4)
			$wago = '4 weeks ago';

		if (isset($visits['w'][$j]))
			{
				$w = $visits['w'][$j]['visits'];
				$uw = $visits['w'][$j]['unique'];
			}
			else
			{
				$w = '-';
				$uw = '-';
			}
		
		echo '<tr>
		<td align=right class="date">', $wago, '</td><td align=right>', $w, '</td><td align=right>'.$uw.'</td></tr>';
	}

	echo '</tbody></table>';
	echo '<table cellpadding=0 cellspacing=0 class="block" border=0 width=100%><thead>
	<tr style="background: #eee;">
	<td width=80 style="border-left: solid 1px #fff;"><nobr>&nbsp; <b>Past year</b></nobr></td>
	<td align=right>Pageviews</td><td align=right>Unique</td></tr></thead>
	<tbody>';
	
	$data = $sql->select(array('table' => 'hits', 'where' => array('type=m')));

	$visits['m'] = array();
	foreach($data as $row){
		$visits['m'][$row['time']] = $row;
	}

	$month = get_time('month');

	for ($i=0; $i<12; $i++){
		if ($i==0)
			{
				$j=$month;
			}
			else
			{
				$days 		= offsetDate('t', offsetMakeGMT(0, 0, 0, offsetDate('n', $month)-1, 1, offsetDate('Y', $month)));
				$j 			= $month - ($days*24*3600);
			}

		$month = $j;

		if (isset($visits['m'][$j]))
			{
				$m = $visits['m'][$j]['visits'];
				$um = $visits['m'][$j]['unique'];
			}
			else
			{
				$m = '-';
				$um = '-';
			}
		
		echo '<tr>
		<td align=right class="date">', date('M`y',$j), '</td><td align=right>', $m, '</td><td align=right>'.$um.'</td></tr>';
	}

	echo '</tbody></table>';
	echo '</td></tr></table>';
}

if($_POST['a'] == 'pages-popular'){

	$select = array(
		'url', 'title', 'time', 'count'	
	);

	$ppop = $sql->select(array('select' => $select, 'table' => 'pages', 'orderby' => array('count','desc')));

	echo '<table cellpadding=0 cellspacing=0 border=0 width=100% class=normal>';

	foreach($ppop as $key => $rec){

		if($key == 30)
			break;

		$rec['title'] = stripslashes($rec['title']);
		$title = $rec['title'];
		$url = str_replace('http://', '', $rec['url']);

		if(strlen($rec['title']) > 40)
			$title = substr($title, 0, 40).'...';
		if(strlen($rec['url']) > 50)
			$url = substr($url, 0, 50).'...';

		echo '<tr><td width=12% align=right style="padding-right: 30px">', $rec['count'], 
		'</td><td width=43% align=left style="padding-left: 8px;">', '<span title="', $rec['title'] ,'">', $title, 
		'</span></td><td width=45% align=left style="padding-left: 8px;">', 
		'<a href="', $rec['url'] ,'" title="', $rec['url'] ,'" target=_blank onclick="window.open(this.href); return false;">', $url ,'</a></td></tr>';
	}
	
	echo '</tbody></table>';
}

if($_POST['a'] == 'pages-recent'){
	
	$ppop = $sql->select(array('table' => 'recent', 'orderby' => array('time','desc')));

	echo '<table cellpadding=0 cellspacing=0 border=0 width=100% class=normal>';

	foreach($ppop as $key => $rec){

		if($key == 30)
			break;

		if(trim($rec['from']) == "")
			$rec['from'] = '-';

		$rec['title'] = stripslashes($rec['title']);
		$title = $rec['title'];
		$url = str_replace('http://', '', $rec['url']);
		$from = str_replace('http://', '', $rec['from']);
		$from = preg_replace("/^".$_SERVER['SERVER_NAME']."/","",$from);

		if($from == "") $from = '/';

		if(strlen($title) > 40)
			$title = substr($title, 0, 40).'...';
		if(strlen($url) > 50)
			$url = substr($url, 0, 50).'...';
		if(strlen($from) > 50)
			$from = substr($from, 0, 50).'...';

		echo '<tr><td width=40% align=left style="padding-left: 8px">', 
		'<a href="', $rec['url'] ,'" onclick="window.open(this.href); return false;" title="', $rec['title'] ,'">', $title, 
		'</a></td><td width=40% align=left style="padding-left: 8px;">';

		if($from != '-')
			echo '<a href="', $rec['from'] ,'" title="', $rec['from'] ,'" onclick="window.open(this.href); return false;">', $from ,'</a>';
		else
			echo $from;

		echo '</td>',
		'<td width=20% align=left style="padding-left: 8px;">', formatDateTimeRelative($rec['time']), '</td></tr>';
	}
	
	echo '</tbody></table>';
}

/***********************************************************************************************/

if($_POST['vs'] === "1"){
	$switch = "pro";
	include "upgrade.php";
	exit;
}

?>