<?php

function ref_info($ref){

  $domain = preg_replace('/(^([^:]+):\/\/(www\.)?|(:\d+)?\/.*$)/', '', $ref);
	$full_name = '';

  $image_search = 0;

  if (!empty($ref)){
    $ref_local = (preg_match("/^([^:]+):\/\/([a-z0-9]+[\._-])*(".str_replace('.', '\.', $_SERVER['SERVER_NAME']).")/i", $ref))? 1 : 0;

    if (!$ref_local){
      include('helpers/engines.php');

      $search_sites = array(); $search_query = array(); $image_sites = array(); $image_paths = array(); $image_results = array();

      foreach ($sengine as $engine){
        $search_sites[] = preg_quote($engine['domain']);
        if (!empty($engine['query']) && !in_array($engine['query'], $search_query)){
          $search_query[] = $engine['query'];
	}

          if (isset($engine['images'])){
            $image_results[$engine['domain']] = $engine['image_results'];
            if ($engine['images']{0} == '/')
              $image_paths[] = preg_quote($engine['images']);	
            else
              $image_sites[] = preg_quote($engine['images']);
						
          }
      }

      if (preg_match('!('.join('|', $search_sites).')\.[^/]*/(?:(?:[^\?&]*(?:\?|&))+(?:'.join('|', $search_query).')=)([^&]*)!i', html_entity_decode($ref), $q)){
        if (!empty($q[2])){
          $search = clean_url(stripslashes(urldecode(preg_replace('/%u([\d\w]{4})/', '&#x$1;', htmlentities($q[2])))));

          if (preg_match('!^https?://(('.join('|', $image_sites).')|[^/]+('.join('|', $image_paths).'))!i', $ref)){
		$image_path = $image_results[$q[1]];
		//$full_name = 
		$image_search = 1;
          }
        }
      }
      else if (strpos($ref, 'images.google.') !== false && preg_match('!prev=([^&]+)!i', html_entity_decode($ref), $p)){
        if (!empty($p[1]) && preg_match('!q=([^&]+)!i', urldecode($p[1]), $q)){
	  if (!empty($q[1])){
            $search = clean_url(stripslashes(urldecode(preg_replace('/%u([\d\w]{4})/', '&#x$1;', htmlentities($q[1])))));
            $image_path = $image_results['google'];
            $image_search = 1;
          }
        }
      }

      if (isset($image_search) and $image_search == 1){
        $ref = 'http://'.$domain.$image_path.urlencode($search);
      }
    }
  }

  if(isset($q[1])){
	foreach($sengine as $e){
		if($e['domain'] == $q[1]){
			$full_name = $e['name'];
			break;
		}
	}
  }

  return array(
	'name' => $full_name,
	'referer' => $ref,
	'is_local' => $ref_local,
	'search_terms' => $search,
	'is_image_search' => $image_search
  );
}

?>