<?php

error_reporting(0);
define('PREFIX','ZOOMS');

if(isset($_SERVER['QUERY_STRING']) and $_SERVER['QUERY_STRING'] == "js"){
	header('Content-type: text/javascript');
	header("Cache-Control: no-store, no-cache, must-revalidate");
	header("Cache-Control: post-check=0, pre-check=0", false);
	header("Pragma: no-cache");

	$path = 'http://'.$_SERVER['SERVER_NAME'].$_SERVER['SCRIPT_NAME'];

	include "helpers/cookie.php";
	setcookie(PREFIX.'allow', 1);

	echo str_replace('{PATH}', $path, file_get_contents('js/s.js'));
	exit;
}

if(isset($_SERVER['QUERY_STRING']) and $_SERVER['QUERY_STRING'] == "logout"){
	session_start();
	unset($_SESSION['stat_admin']);

	header('location:'.$_SERVER['SCRIPT_NAME']);
	exit;
}

if(isset($_POST['password'])){
	include "connect.php";

	$config = $sql->select(array('table' => 'config','where' => array('id=1')));

	if($config[0]['pass'] == md5($_POST['password'])){
		session_start();
		$_SESSION['stat_admin'] = 1;
	}

	header('location:'.$_SERVER['SCRIPT_NAME']);
	exit;
}

if(isset($_POST['login_temp'])){
	include "connect.php";

	$config = $sql->select(array('table' => 'config','where' => array('id=1')));

	if($config[0]['pass'] == md5($_POST['pass'])){
		session_start();
		$_SESSION['stat_admin'] = 1;
	}

	header('location:'.$_SERVER['SCRIPT_NAME']);
	exit;
}

if(isset($_POST['pref'])){
	
	include "connect.php";
	$data = array();

	if(isset($_POST['protect'])){
		$data['protect'] = 'off';
	}
	else
		$data['protect'] = 'on';
	if(isset($_POST['offset'])){
		$data['offset'] = $_POST['offset'];
	}
	if(isset($_POST['pass']) and $_POST['pass']!=''){
		$data['pass'] = md5($_POST['pass']);
	}

	$sql->update(array('table' => 'config', 'values' => $data, 'where' => array('id=1')));
	header('location:'.$_SERVER['SCRIPT_NAME']);

	exit;
}

if(isset($_SERVER['QUERY_STRING']) and $_SERVER['QUERY_STRING'] == "rss1"){

	include "connect.php";
	$config = $sql->select(array('table' => 'config','where' => array('id=1')));

	include "helpers/time.php";

	$data = $sql->select(array('table' => 'hits', 'where' => array('type=h')));

	$visits['h'] = array();
	foreach($data as $row){
		$visits['h'][$row['time']] = $row;
	}

	$hour = get_time('hour');
	$path = str_replace('index.php','','http://'.$_SERVER['SERVER_NAME'].$_SERVER['SCRIPT_NAME']);

	header('Content-type: text/xml');

echo '<?xml version="1.0" encoding="utf-8"?>
<rss version="2.0">
	<channel>
		<title>Zoom Stats</title>
		<link>'.$path.'</link>
		<description>Zoom Stats - Past Day</description>
		<lastBuildDate>'.gmdate("D, d M Y H:i:s")." GMT".'</lastBuildDate>
';

	for ($i=0; $i<24; $i++){
		$j = $hour - ($i*60*60);

		if (isset($visits['h'][$j])){
			$h = $visits['h'][$j]['visits']; $uh = $visits['h'][$j]['unique'];
		} else {
			$h = '0'; $uh = '0';
		}

echo '<item>
	<title>'.date('H:i',$j).' - p: '.$h.' / u: '.$uh.'</title>
	<description><![CDATA[]]></description>
	<link>'.$path.'</link>
</item>
';
	}

echo'	</channel>
</rss>';

	exit;

}

if(isset($_SERVER['QUERY_STRING']) and $_SERVER['QUERY_STRING'] == "rss2"){

	include "connect.php";
	$config = $sql->select(array('table' => 'config','where' => array('id=1')));

	include "helpers/time.php";

	$data = $sql->select(array('table' => 'recent', 'orderby' => array('time','desc')));

	$path = str_replace('index.php','','http://'.$_SERVER['SERVER_NAME'].$_SERVER['SCRIPT_NAME']);

	header('Content-type: text/xml');

echo '<?xml version="1.0" encoding="utf-8"?>
<rss version="2.0">
	<channel>
		<title>Zoom Stats</title>
		<link>'.$path.'</link>
		<description>Zoom Stats - Past Day</description>
		<lastBuildDate>'.gmdate("D, d M Y H:i:s")." GMT".'</lastBuildDate>
';	

	foreach($data as $key => $rec){

		if($key == 30)
			break;

		if(trim($rec['from']) == "")
			$rec['from'] = '-';

		$rec['title'] = stripslashes(htmlspecialchars($rec['title']));

echo '<item>
	<title>'.htmlspecialchars($rec['title']).'</title>
	<description><![CDATA['.'From: '.$rec['from'].']]></description>
	<link>'.htmlspecialchars($rec['url']).'</link>
	<pubDate>'.gmdate("D, d M Y H:i:s", $rec['time']).' GMT'.'</pubDate>
</item>
';

		
	}

echo'	</channel>
</rss>';

	exit;
}

else if(isset($_SERVER['QUERY_STRING']) and preg_match("/^rec/",$_SERVER['QUERY_STRING'],$m)){
	
	include "connect.php";
	$config = $sql->select(array('table' => 'config','where' => array('id=1')));

	include 'helpers/check.php';
	include 'helpers/url.php';
	include "helpers/cookie.php";
	include 'helpers/referer.php';
	include 'helpers/time.php';
	include 'helpers/user_agents.php';
	
	$check = checkup();

	/*** Set cookies for each period ***/

	set_cookie(PREFIX.'allow', 1, time());

	$allow_cookie = false;
	if(isset($_COOKIE[PREFIX.'allow']))
		$allow_cookie = true;

	$_h = 0; $_d = 0; $_w = 0; $_m = 0; $_y = 0; $_all = 0;

	if(!isset($_COOKIE[PREFIX.'all'])){
		$_all = 1;
		set_cookie(PREFIX.'all', 1, time() + 60*60*24*31*12*10);
	}
	if(!isset($_COOKIE[PREFIX.'hour'])){
		$_h = 1;
		set_cookie(PREFIX.'hour', 1, time_interval('hour', false) + 60*60);
	}
	if(!isset($_COOKIE[PREFIX.'day'])){
		$_d = 1;
		set_cookie(PREFIX.'day', 1, time_interval('day', false) + 60*60*24);		
	}
	if(!isset($_COOKIE[PREFIX.'week'])){
		$_w = 1;
		set_cookie(PREFIX.'week', 1, time_interval('week', false) + 60*60*24*7);
	}
	if(!isset($_COOKIE[PREFIX.'month'])){
		$_m = 1;
		set_cookie(PREFIX.'month', 1, time_interval('month', false) + 60*60*24*31);
	}

	function save_stat($data,$type,$u,$time){

		global $sql, $allow_cookie;

		if(isset($data[0])){

			if($type == "all") $time = $data[0]['time'];

			$visits = $data[0]['visits'] + 1;
			if($u == 1 and $allow_cookie !== false)
				$uvisits = $data[0]['unique'] + 1;
			else 
				$uvisits = $data[0]['unique'];

			$values = array(
				'visits' => $visits,
				'unique' => $uvisits
			);

			$sql->update(array('table' => 'hits', 'values' => $values, 'where' => array('type='.$type,'and','time='.$time)));
		}
		else {
			if($type == "all") $time = time();

			$visits = 1;
			if($u == 1 and $allow_cookie !== false)
				$uvisits = 1;
			else
				$uvisits = 0;

			$values = array(
				'time' => $time,
				'type' => $type,
				'visits' => $visits,
				'unique' => $uvisits
			);

		$sql->insert(array('table' => 'hits', 'values' => $values));
		}
	}

	/*** Save visits in database ***/

	$data = $sql->select(array('table' => 'hits', 'where' => array('type=all')));
	save_stat($data,'all',$_all,'');

	$hour = get_time('hour');
	$data = $sql->select(array('table' => 'hits', 'where' => array('type=h','and','time='.$hour)));
	save_stat($data,'h',$_h,$hour);

	$day = get_time('day');
	$data = $sql->select(array('table' => 'hits', 'where' => array('type=d','and','time='.$day)));
	save_stat($data,'d',$_d,$day);

	$week = get_time('week');
	$data = $sql->select(array('table' => 'hits', 'where' => array('type=w','and','time='.$week)));
	save_stat($data,'w',$_w,$week);

	$month = get_time('month');
	$data = $sql->select(array('table' => 'hits', 'where' => array('type=m','and','time='.$month)));
	save_stat($data,'m',$_m,$month);

	if(mt_rand(1,6) % 4 == 0)
	{
		$sql->delete(array('table' => 'hits', 'where' => array('type=h','and','time<'.(time() - 3600*60))));
		$sql->delete(array('table' => 'hits', 'where' => array('type=d','and','time<'.(time() - 3600*24*10))));
	}

	/*** Pages, Refs and other stuff ***/

	$ref = normal_url(clean_url($_GET['ref']));
	$ttl = trim(str_replace('\n', ' ', preg_replace('/%u([\d\w]{4})/', '&#x$1;', $_GET['ttl'])));

	$info = ref_info($ref);

	$_GET['url'] = normal_url(clean_url($_GET['url']));


	/* Save recent pages */

	if(isset($ttl) and $ttl != "" and isset($_GET['url']) and $_GET['url'] != ""){
	
		$ref_type = -1;
		if(isset($info['is_local']) and $info['is_local'] == 1)
			$ref_type = 0;
		else {
			if($info['search_terms'] != "")
				$ref_type = 2;
			else if(isset($info['is_local']))
				$ref_type = 1;
		}

		$data = array(
			'url' => $_GET['url'],
			'title' => $ttl,
			'time' => time(),
			'ref_type' => $ref_type,
			'keywords' => $info['search_terms'],
			'from' => $info['referer'],
		);

		$sql->insert(array('table' => 'recent', 'values' => $data));

		/* Delete old recent entries */

		if(mt_rand(1,6) % 4 == 0)
		{

		  define('DELETE_AFTER', 29);

		  if($ref_type === 1){
			  $ref = $sql->select(array('table' => 'recent', 'where' => array('ref_type=1'), 'orderby' => array('time','desc')));
			  if(isset($ref[DELETE_AFTER]))
				  $sql->delete(array('table' => 'recent', 'where' => array('ref_type=1','and','time<'.$ref[DELETE_AFTER]['time'])));
		  }

		  if($ref_type === 0){
			  $local = $sql->select(array('table' => 'recent', 'where' => array('ref_type=0'), 'orderby' => array('time','desc')));
			  if(isset($local[DELETE_AFTER]))
				  $sql->delete(array('table' => 'recent', 'where' => array('ref_type=0','and','time<'.$local[DELETE_AFTER]['time'])));
		  }

		  if($ref_type == 2){
			  $se = $sql->select(array('table' => 'recent', 'where' => array('ref_type=2'), 'orderby' => array('time','desc')));
			  if(isset($se[DELETE_AFTER]))
				  $sql->delete(array('table' => 'recent', 'where' => array('ref_type=2','and','time<'.$se[DELETE_AFTER]['time'])));
		  }

		  if($ref_type == -1){
			  $void = $sql->select(array('table' => 'recent', 'where' => array('ref_type=-1'), 'orderby' => array('time','desc')));
			  if(isset($void[DELETE_AFTER]))
				  $sql->delete(array('table' => 'recent', 'where' => array('ref_type=-1','and','time<'.$void[DELETE_AFTER]['time'])));
		  }

		}

		/* With p = 0,167 entry will be deleted */
	}


	if(isset($ttl) and $ttl != ""){

		$search = $sql->select(array('table' => 'pages', 'where' => array('url='.$_GET['url'])));

		$ref_type = -1;
		if(isset($info['is_local']) and $info['is_local'] == 1)
			$ref_type = 0;
		else {
			if($info['search_terms'] != "")
				$ref_type = 2;
			else if(isset($info['is_local']))
				$ref_type = 1;
		}

		if($ref_type == 1 and $check == "1"){
			$ref = $sql->select(array('table' => 'refs', 'where' => array('url='.$_GET['url'],'and','from='.$info['referer'])));
			
			$rdata = array(
				'url' => $_GET['url'],
				'title' => $ttl,
				'from' => $info['referer'],
			);
		
			if(isset($ref[0])){
				$rdata['count'] = ++$ref[0]['count'];
				$sql->update(array('table' => 'refs', 'values' => $rdata, 'where' => array('url='.$_GET['url'],'and','from='.$info['referer'])));
			}
			else {
				$rdata['count'] = 1;
				$rdata['time'] = time();
				$sql->insert(array('table' => 'refs', 'values' => $rdata));
			}
		}

		if($ref_type == 2 and $check == "1"){
			$ser = $sql->select(array('table' => 'search', 'where' => array('keywords='.$info['search_terms'])));
			
			$sdata = array(
				'url' => $_GET['url'],
				'title' => $ttl,
				'from' => $info['referer'],
				'keywords' => $info['search_terms']
			);
		
			if(isset($ser[0])){
				$sdata['count'] = ++$ser[0]['count'];
				$sql->update(array('table' => 'search', 'values' => $sdata, 'where' => array('keywords='.$info['search_terms'])));
			}
			else {
				$sdata['count'] = 1;
				$sql->insert(array('table' => 'search', 'values' => $sdata));
			}

			if(isset($info['name']) and $info['name'] != ''){
				$sn = $sql->select(array('table' => 'engines', 'where' => array('name='.$info['name'])));
			
				$sndata = array();
		
				if(isset($sn[0])){
					$sndata['count'] = ++$sn[0]['count'];
					$sql->update(array('table' => 'engines', 'values' => $sndata, 'where' => array('name='.$info['name'])));
				}
				else {
					$sndata['name'] = $info['name'];
					$sndata['count'] = 1;
					$sql->insert(array('table' => 'engines', 'values' => $sndata));
				}	
			}
		}

		$data = array(
			'url' => $_GET['url'],
			'title' => $ttl,
			'time' => time(),
			'ref_type' => $ref_type,
			'from' => $info['referer'],
		);

		if(isset($search[0])){
			$data['count'] = ++$search[0]['count'];
			$sql->update(array('table' => 'pages', 'values' => $data, 'where' => array('url='.$_GET['url'])));
		}
		else {
			$data['count'] = 1;
			$sql->insert(array('table' => 'pages', 'values' => $data));
		}
	}

	if(isset($_GET['bro']) and $_GET['bro'] != '' and $check == "1"){
		$_GET['bro'] = get_user_agent($_GET['bro']);

		if($_GET['bro'] == '')
			$_GET['bro'] = 'Other';

		$data = $sql->select(array('table' => 'agents', 'where' => array('name='.$_GET['bro'])));

		$values = array();
	
		if(isset($data[0])){
			$values['count'] = ++$data[0]['count'];
			$sql->update(array('table' => 'agents', 'values' => $values, 'where' => array('name='.$data[0]['name'])));
		}
		else{
			$values['name'] = $_GET['bro'];
			$values['count'] = 1;
			$sql->insert(array('table' => 'agents', 'values' => $values));
		}
	}
		
}

else {
	session_start();

	include "connect.php";

	$config = $sql->select(array('table' => 'config','where' => array('id=1')));

	include "helpers/time.php";

	if(!isset($_SESSION['stat_admin']) and $config[0]['protect'] == 'on'){
		echo '<html><head><title></title></head><body style="background: #dee7f6; font-family: Tahoma; font-size: 11px">',
		'<center><form method="post" action="" style="padding: 0px; margin: 0px;">',		
		'<div style="margin: 5px; margin-top: 50px; background: #fff; border: solid 1px #99bbe8; width: 270px;">',
		'<div style="background: url(\'images/title.gif\') repeat-x; height: 25px; text-align: left; padding-top: 4px; padding-left: 4px;"><b>Login</b></div>',
		'<div style="padding: 4px; width: 100%; padding-bottom: 10px;">Password: <input type="password" size=12 name="password">&nbsp;<input type="submit" value="Go"></div></div></center>',
		'</form></body></html>';

		exit;
	}

	define('DIRECT_ACCESS',TRUE);

	include "helpers/check.php";
	
	$check = checkup();

	include "_admin.php";
}
	
?>