<?php if (!defined('DIRECT_ACCESS')) { exit; }; ?>

<html>
<head>
<script src="js/jquery-1.2.3.pack.js" type="text/javascript"></script>
<!--[if IE]><script language="javascript" type="text/javascript" src="js/excanvas.pack.js"></script><![endif]-->
<script language="javascript" type="text/javascript" src="js/jquery.flot.pack.js"></script>
<script src="js/control.js" type="text/javascript"></script>
<script type="text/javascript">
	var VERSION_STATUS = <?php echo $check; ?>;
</script>

<style>

body {
	margin: 0px;
	padding: 0px;
	background: #f5f4dc;
	font-family: 'Tahoma', sans-serif;
	font-size: 11px;
	background-color: #101010;
}

a {
	color: #000;
	text-decoration: none;
}

a:hover {
	text-decoration: underline;
}

#left {
	float: left;
	background: #101010;
	width: 20%;
	margin-top: 0px; // 27
}

#right {
	float: right;
	background: #101010;
	width: 80%;
	margin-top: 0px;
}

#left-title, #right-title {
	background: url('images/title.gif') repeat-x; 
	height: 25px;
	
	color: #133E84;
	font-weight: bold;
	font-family: 'Tahoma', sans-serif;
	font-size: 11px;
}

#right-title {
	background: url('images/right-title.gif') repeat-x; 
	height: 26px;
}

#rss-title {
	background: url('images/rss-title.gif') repeat-x; 
	height: 26px;
	
	color: #000;
	font-family: 'Tahoma', sans-serif;
	font-size: 11px;
}

#under-rss {
	background: url('images/under-rss.gif') repeat-x; 
	height: 24px;
	color: #000;
	font-family: 'Tahoma', sans-serif;
	font-size: 11px;
}

#panes, #opt {
	color: #000;
	font-family: 'Tahoma', sans-serif;
	font-size: 11px;
	
	padding: 4px;
}

#panes div {
	padding: 4px;
	padding-left: 10px;
}

.pane-over {
	background: #eee;
	cursor: pointer;
}

#rss-title div {
	padding-top: 4px; padding-left: 6px;
}

#left-title div {
	padding-top: 4px; padding-left: 6px;
}

.tab-over {
	background: url('images/tab-over.gif') repeat-x;
	cursor: pointer;
	border: solid 1px #f2ebd8;
}

.tab-clicked {
	background: url('images/tab-clicked.gif') repeat-x;
	cursor: pointer;
	border: solid 1px #f2ebd8;
}

.tab {
	border: solid 1px #D5E2F2;
}

.main, .main table {
	color: #000;
	font-family: 'Tahoma', sans-serif;
	font-size: 11px;
}

table.visitors table tr td, table.normal td, table.ref-class-cell td, table.ser-class-cell td {
	border-bottom: solid 1px #ededed;
	padding: 3px;
}

.cell-hover {
	background: url('images/cell-hover.gif') repeat-x;
	cursor: pointer;
	border: solid 1px red;
}

.cell-clicked {
	background: #DFE8F6;
}

.cell-clicked td {
	background: #DFE8F6;
}

.tab-bar {
	height: 26px; 
	background: url('images/tabs_bg.gif') repeat-x; 
	font-family: 'Tahoma'; font-size: 11px;
}

.tab-bar div {
	float: left; 
	margin: 2px 0px 0px 2px; 
	padding: 3px;
}

#mainh table td {
	font-family: 'Tahoma'; 
	font-size: 11px;
	padding-top: 0px;
	padding-left: 4px;
	border-right: solid 1px #d0d0d0;
	border-left: solid 1px #eee;
}
.style7 {font-family: Arial, Helvetica, sans-serif; font-size: 22px; font-weight: bold; color: #EFF0F2;}
</style>

<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"><title>Zoom Stats Viewing Panel</title></head>
<link href="favicon.ico" rel="shortcut icon" type="image/x-icon" />


<body>

<div style="width: 100%; height: 27px;">
	&nbsp;&nbsp;&nbsp;<img src="images/logo.png" width="146" height="23">
</div>

<div id="left">
	<div style="margin: 5px; background: #fff; border: solid 1px #f2ebd8;">
		<div id="left-title">
			<div>Stats</div>
		</div>
		<div id="rss-title">
			<div>
				<a href="?rss1" style="text-decoration: none;" target="_blank">
					<img src="images/rss-logo.gif" border="0" width="14" height="14">&nbsp;Past Day &nbsp;&nbsp;
				</a>
				<a href="?rss2" style="text-decoration: none;" target="_blank">
					<img src="images/rss-logo.gif" border="0" width="14" height="14">&nbsp;Recent Pages
				</a>
			</div>
		</div>
		<div id="under-rss">
			<div style="padding-top: 5px; padding-left: 6px;">
				My panes
			</div>
		</div>
		<div id="panes">
			<div style="padding: 4px; padding-left: 10px;" id="p1">
				<img src="images/stat-small.png" width="14" height="14" align="left">&nbsp;Pageviews / Unique
			</div>
			<div style="clear: both; padding: 4px; padding-left: 10px;" id="p2">
				<img src="images/stat-small.png" width="14" height="14" align="left">&nbsp;Pages
			</div> 
			<div style="clear: both; padding: 4px; padding-left: 10px;" id="p3">
				<img src="images/stat-small.png" width="14" height="14" align="left">&nbsp;Referers
			</div>
			<div style="clear: both; padding: 4px; padding-left: 10px;" id="p4">
				<img src="images/stat-small.png" width="14" height="14" align="left">&nbsp;Search Engines
			</div>
			<div style="clear: both; padding: 4px; padding-left: 10px;" id="p5">
				<img src="images/stat-small.png" width="14" height="14" align="left">&nbsp;User Browsers
			</div>
		</div>
		<div id="under-rss">
			<div style="padding-top: 5px; padding-left: 6px;">
				Options
			</div>
		</div>
		<div id="opt">
		
			<?php if(isset($_SESSION['stat_admin'])){ ?>

			<div style="padding: 4px; padding-left: 10px;">
				<a href="index.php?logout" style="text-decoration: none;">
					<img src="images/conf-small.png" width="14" border=0 height="14" align="left">&nbsp;Logout
				</a>
			</div>
			<div style="padding: 4px; padding-left: 10px;" id="pref1">
				<img src="images/conf-small.png" width="14" height="14" align="left">&nbsp;Preferences
			</div>

			<?php } else { ?>

			<div style="padding: 4px; padding-left: 10px;" id="pref0">
				<img src="images/conf-small.png" width="14" height="14" align="left">&nbsp;LogIn
			</div>	

			<?php } ?>

		</div>

		<?php if(isset($_SESSION['stat_admin'])){ ?>

		<div id="pref" style="display: none; border-left: solid 1px #c0c0c0; margin-left: 10px; padding-left: 5px; padding-bottom: 1px; margin-top: 2px">
			<form method="post" action="" style="padding: 0px; margin: 0px">
			<div style="float: right; margin-right: 5px;">
				<input type="hidden" name="pref" value="1">
				<input type="submit" value="ok" style="width: 35px"></div>
				<input type="checkbox" name="protect" <?php echo $config[0]['protect'] != 'on' ? 'checked' : ''; ?>> Free access to stats<br><br>
				
				Insert Code: (after &lt;title&gt; tag)<br><input style="font-family: 'courier new'; font-size: 12px" type="text" value='<?php echo '<script src="http://'.str_replace('index.php','?js',$_SERVER['SERVER_NAME'].$_SERVER['SCRIPT_NAME']).'" type="text/javascript"></script>'; ?>'><br><br>
				<a href="" id="syn"><img src="images/syn.gif" border="0" align="left">Synchronize Local & Server Time</a><br><br>
				New password: <input type="password" name="pass">
					
			</form>
		</div>

		<?php } else { ?>

		<div id="lg" style="display: none; border-left: solid 1px #c0c0c0; margin-left: 10px; padding-left: 5px; padding-bottom: 1px; margin-top: 2px">
			<form method="post" action="" style="padding: 0px; margin: 0px">
				Password:
				<input type="hidden" name="login_temp" value=1>
				<br><input type="password" name="pass" style="width: 110px;">
				<input type="submit" value="ok" style="width: 35px">
			</form>
		</div>

		<?php } ?>

	</div>
</div>

<div id="right">
	<div style="margin: 5px; margin-left: 0px; background: #fff; border: solid 1px #f2ebd8;">
		<div id="right-title">
			<div style="background: url('images/tab.gif') no-repeat 1px 1px; margin-left: 1px; height: 26px;">
				<div style="padding-top: 6px; padding-left: 8px;">Pageviews / Unique</div>
			</div>
		</div>

		<div class="tab-bar" id="tb1">
			<div class="tab-clicked" id="vis1">
				<img src="images/tab-logo.gif" width="15" height="13" align="left">&nbsp;Overview
			</div>
			<div class="tab" id="vis2">
				<img src="images/tab-logo.gif" width="15" height="13" align="left">&nbsp;Past Day
			</div>
			<div class="tab" id="vis3">
				<img src="images/tab-logo.gif" width="15" height="13" align="left">&nbsp;Past Week
			</div>
			<div class="tab" id="vis4">
				<img src="images/tab-logo.gif" width="15" height="13" align="left">&nbsp;Past Month
			</div>
			<div class="tab" id="vis5">
				<img src="images/tab-logo.gif" width="15" height="13" align="left">&nbsp;Past Year
			</div>
		</div>

		<div class="tab-bar" id="tb2" style="display: none;">
			<div class="tab-clicked" id="pages1">
				<img src="images/tab-logo.gif" width="15" height="13" align="left">&nbsp;Most Popular
			</div>
			<div class="tab" id="pages2">
				<img src="images/tab-logo.gif" width="15" height="13" align="left">&nbsp;Most Recent
			</div>
		</div>

		<div class="tab-bar" id="tb3" style="display: none;">
			<div class="tab-clicked" id="ref1">
				<img src="images/tab-logo.gif" width="15" height="13" align="left">&nbsp;Traffic Leaders
			</div>
			<div class="tab" id="ref2">
				<img src="images/tab-logo.gif" width="15" height="13" align="left">&nbsp;Most Recent
			</div>
			<div class="tab" id="ref3">
				<img src="images/tab-logo.gif" width="15" height="13" align="left">&nbsp;Newest Unique
			</div>
		</div>

		<div class="tab-bar" id="tb4" style="display: none;">
			<div class="tab-clicked" id="ser1">
				<img src="images/tab-logo.gif" width="15" height="13" align="left">&nbsp;Most Common
			</div>
			<div class="tab" id="ser2">
				<img src="images/tab-logo.gif" width="15" height="13" align="left">&nbsp;Most Recent
			</div>
			<div class="tab" id="ser3">
				<img src="images/tab-logo.gif" width="15" height="13" align="left">&nbsp;Percentage
			</div>
		</div>

		<div class="tab-bar" id="tb5" style="display: none;">
			<div class="tab-clicked" id="bro1">
				<img src="images/tab-logo.gif" width="15" height="13" align="left">&nbsp;Percentage
			</div>
		</div>

		<div id="mainh" style="height: 24px; background: url('images/stat-title.gif') repeat-x;">
			&nbsp;
		</div>

		<div id="main1" class="main" style="overflow: hidden;">
			
		</div>

		<div id="main2" class="main" style="overflow: hidden; display: none;">
			<div>

			</div>
		</div>

		<div id="main3" class="main" style="overflow: hidden; display: none;">
			<div>

			</div>
		</div>

		<div id="main4" class="main" style="overflow: hidden; display: none;">
			<div>

			</div>
		</div>

		<div id="main5" class="main" style="overflow: hidden; display: none;">
			&nbsp;
		</div>

	</div>
</div>

</body>
</html>