$(document).ready(function(){

	var MSG = 'Not available for Zoom Stats Lite. Please upgrade to Pro version to enjoy all features';

	if(VERSION_STATUS == 0)
		$('#p3, #p4, #p5').css('opacity', 0.5);

	resizeWin();

	$(window).resize(function(){
		resizeWin();
	});

	$('#panes > div, #opt > div, #lg > div').mouseover(function(){
		$(this).addClass('pane-over');
	});
	$('#panes > div, #opt > div, #lg > div').mouseout(function(){
		$(this).removeClass('pane-over');
	});

	tabsHover();

	

	$.post("_loader.php", {'a' : 'vis-overview', 'vs': VERSION_STATUS}, function(data){
		$('#main1').html(data); stopIndicator(); $('#main1 > table').css('width',$('#right').width() - 25 );

		cellHighlight('table.block tbody tr');

		$.post("_loader.php", {'a' : 'pages-popular', 'vs': VERSION_STATUS}, function(data){
			$('#main2 > div').html(data); stopIndicator();

			cellHighlight('table.normal tr');

			$.post("_loader.php", {'a' : 'ref-leaders', 'vs': VERSION_STATUS}, function(data){
				$('#main3 > div').html(data); stopIndicator();

				cellHighlight('table.ref-class-cell tr');

				$.post("_loader.php", {'a' : 'ser-common', 'vs': VERSION_STATUS}, function(data){
					$('#main4 > div').html(data); stopIndicator();

					cellHighlight('table.ser-class-cell tr');
				});
			});
		});
	});

	$('#syn').click(function(){
		var d = new Date();
		var dStr = d.getHours() + '::' + d.getMonth() + '::' + d.getUTCDate() + '::' + d.getFullYear();

		$.post("_loader.php", {'a' : 'syn', 'dStr': dStr, 'vs': VERSION_STATUS}, function(data){
			document.location = document.location;
		});

		return false;
	});


	/********************************* Actions : Panes *******************************/

	$('#p1').click(function(){
		$('div.main, div.tab-bar').hide();
		$('div#main1, div#tb1').show();
		$('#right-title > div > div').text('Pageviews / Unique');

		mainh_0();
	});

	$('#p2').click(function(){
		$('div.main, div.tab-bar').hide();
		$('div#main2, div#tb2').show();
		$('#right-title > div > div').text('Pages');

		var which_tab = $('div#tb2 > div.tab-clicked').attr('id');

		if(which_tab == 'pages1')
			mainh_1();
		else
			mainh_2();
	});

	$('#p3').click(function(){

		if(VERSION_STATUS == 0){
			alert(MSG); return false;
		}

		$('div.main, div.tab-bar').hide();
		$('div#main3, div#tb3').show();
		$('#right-title > div > div').text('Referers');

		var which_tab = $('div#tb3 > div.tab-clicked').attr('id');

		if(which_tab == 'ref1')
			mainh_3();
		else
			mainh_4();
	});


	$('#p4').click(function(){

		if(VERSION_STATUS == 0){
			alert(MSG); return false;
		}

		$('div.main, div.tab-bar').hide();
		$('div#main4, div#tb4').show();
		$('#right-title > div > div').text('Search Engines');

		var which_tab = $('div#tb4 > div.tab-clicked').attr('id');

		if(which_tab == 'ser1')
			mainh_5();
		else if(which_tab == 'ser2')
			mainh_6();
		else
			mainh_0();
	});

	$('#p5').click(function(){

		if(VERSION_STATUS == 0){
			alert(MSG); return false;
		}

		$('div.main, div.tab-bar').hide();
		$('div#main5, div#tb5').show();
		$('#right-title > div > div').text('User Browsers');

		mainh_0();

		loadBroPercent();
	});

	$('#opt #pref1').toggle(function(){
		$('#pref').show();
	},function(){ $('#pref').hide(); });

	$('#pref0').toggle(function(){
		$('#lg').show();
	},function(){ $('#lg').hide(); });

	/********************************* Actions : Tabs *******************************/

	function changeTabs(that){
		$(that).children('img').attr('src', 'images/indicator.gif');

		$(that).parent().children().removeClass('tab-clicked').removeClass('tab-over').addClass('tab');;
		$(that).addClass('tab-clicked').removeClass('tab');

		tabsHover();
	}

	$('#vis1').click(function(){
		changeTabs(this); loadVisOverview();
	});

	$('#vis2').click(function(){
		changeTabs(this); loadVisPastDay();
	});

	$('#vis3').click(function(){
		changeTabs(this); loadVisPastWeek();
	});

	$('#vis4').click(function(){
		changeTabs(this); loadVisPastMonth();
	});

	$('#vis5').click(function(){
		changeTabs(this); loadVisPastYear();
	});


	$('#pages1').click(function(){
		changeTabs(this); loadPagesPopular();
		mainh_1();
	});

	$('#pages2').click(function(){
		changeTabs(this); loadPagesRecent();
		mainh_2();
	});


	$('#ref1').click(function(){
		changeTabs(this); loadRefLeaders();
		mainh_3();
	});

	$('#ref2').click(function(){
		changeTabs(this); loadRefRecent();
		mainh_4();
	});

	$('#ref3').click(function(){
		changeTabs(this); loadRefUnique();
		mainh_4();
	});

	$('#ser1').click(function(){
		changeTabs(this); loadSearchCommon();
		mainh_5();
	});

	$('#ser2').click(function(){
		changeTabs(this); loadSearchRecent();
		mainh_6();
	});

	$('#ser3').click(function(){
		changeTabs(this); loadSearchPercent();
		mainh_0();
	});



	$('#bro1').click(function(){
		changeTabs(this); loadBroPercent();
		mainh_0();
	});

});

/********************************* AJAX Requests *******************************/

function insertGraph(){
	$('#main1').html('<center><div id="placeholder" style="margin-top: 35px; width:' + ($('#main1').width() - 130) + 'px; height: ' + ($('#main1').height() - 80) + 'px;"></div></center>');
}

function insertGraph2(w,h){
	$('#main5').html('<center><div id="placeholder2" style="margin-top: 35px; width:' + (w - 130) + 'px; height: ' + (h - 80) + 'px;"></div></center>');
}

function insertGraph3(){
	$('#main4 > div').html('<center><div id="placeholder3" style="margin-top: 35px; width:' + ($('#main4').width() - 130) + 'px; height: ' + ($('#main4').height() - 80) + 'px;"></div></center>');
}

function loadVisPastDay(){
	$.post("_loader.php", {'a' : 'vis-pastday', 'vs': VERSION_STATUS}, function(data){
		insertGraph(); eval(data); stopIndicator();		
	});
}

function loadVisPastWeek(){
	$.post("_loader.php", {'a' : 'vis-pastweek', 'vs': VERSION_STATUS}, function(data){
		insertGraph(); eval(data); stopIndicator();
	});
}

function loadVisPastMonth(){
	$.post("_loader.php", {'a' : 'vis-pastmonth', 'vs': VERSION_STATUS}, function(data){
		insertGraph(); eval(data); stopIndicator();
	});
}

function loadVisPastYear(){
	$.post("_loader.php", {'a' : 'vis-pastyear', 'vs': VERSION_STATUS}, function(data){
		insertGraph(); eval(data); stopIndicator();
	});
}

function loadVisOverview(){
	$.post("_loader.php", {'a' : 'vis-overview', 'vs': VERSION_STATUS}, function(data){
		$('#main1').html(data); stopIndicator();

		$('#main1 > table').css('width',$('#right').width() - 25 );

		cellHighlight('table.block tbody tr');
	});
}

function loadPagesPopular(){
	$.post("_loader.php", {'a' : 'pages-popular', 'vs': VERSION_STATUS}, function(data){
		$('#main2 > div').html(data); stopIndicator();

		cellHighlight('table.normal tr');
	});
}

function loadPagesRecent(){
	$.post("_loader.php", {'a' : 'pages-recent', 'vs': VERSION_STATUS}, function(data){
		$('#main2 > div').html(data); stopIndicator();
	
		cellHighlight('table.normal tr');
	});
}

function loadRefLeaders(){
	$.post("_loader.php", {'a' : 'ref-leaders', 'vs': VERSION_STATUS}, function(data){
		$('#main3 > div').html(data); stopIndicator();

		cellHighlight('table.ref-class-cell tr');
	});
}

function loadRefRecent(){
	$.post("_loader.php", {'a' : 'ref-recent', 'vs': VERSION_STATUS}, function(data){
		$('#main3 > div').html(data); stopIndicator();
		
		cellHighlight('table.ref-class-cell tr');
	});
}

function loadRefUnique(){
	$.post("_loader.php", {'a' : 'ref-unique', 'vs': VERSION_STATUS}, function(data){
		$('#main3 > div').html(data); stopIndicator();

		cellHighlight('table.ref-class-cell tr');
	});
}

function loadSearchCommon(){
	$.post("_loader.php", {'a' : 'ser-common', 'vs': VERSION_STATUS}, function(data){
		$('#main4 > div').html(data); stopIndicator();

		cellHighlight('table.ser-class-cell tr');
	});
}

function loadSearchRecent(){
	$.post("_loader.php", {'a' : 'ser-recent', 'vs': VERSION_STATUS}, function(data){
		$('#main4 > div').html(data); stopIndicator();

		cellHighlight('table.ser-class-cell tr');
	});
}

function loadSearchPercent(){
	$.post("_loader.php", {'a' : 'ser-percent', 'vs': VERSION_STATUS}, function(data){
		insertGraph3(); eval(data); stopIndicator();
	});
}

function loadBroPercent(){
	$.post("_loader.php", {'a' : 'bro-percent', 'vs': VERSION_STATUS}, function(data){
		insertGraph2($('#main5').width(), $('#main5').height()); eval(data);
		stopIndicator();
	});
}


/********************************* Stuff *******************************/

function cellHighlight(select){

	$(select).mouseover(function(){ 
		$(this).addClass('cell-hover');
	});

	$(select).mouseout(function(){ 
		$(this).removeClass('cell-hover');
	});

	$(select).toggle(function(e){

		if($(e.target).attr('nodeName') == "A")
			return false;

		$(this).parent().children().removeClass('cell-clicked');
		$(this).addClass('cell-clicked');
	},

	function(){
		$(this).parent().children().removeClass('cell-clicked');
	});
}

function resizeWin(){
	var w = $(window).width();
	var h = $(window).height();


	$('#left, #right').css('height', h - 32);
	$('#left > div, #right > div').css({'height' : h - 39 + ($.browser.msie ? 2 : 0) });
	$('#right #main1, #main2, #main3, #main4, #main5').css({'height' : h - 116, 'overflow' : 'auto'});
	
	$('#main2 > div, #main3 > div, #main4 > div').css('width',$('#right').width() - 28 );
	$('#main1 > table').css('width',$('#right').width() - 25 );
	$('#pref').css({'height' : h - 310, 'overflow' : 'auto'});
}

function showTooltip(x, y, contents) {
	$('<div id="tooltip">' + contents + '</div>').css({
		'position' : 'absolute',
		'display' : 'none',
		'top' : y + 5,
		'left' : x + 5,
		'font-family' : 'Tahoma',
		'font-size' : '11px',
		'border' : '1px solid #c0c0c0',
		'padding' : '2px',
		'background-color': '#DFE8F6',
		'opacity' : 0.80
       	}).appendTo("body").fadeIn(200);
}

function tabsHover(){
	$('div.tab').mouseover(function(){

		if($(this).attr('class').search(/tab-clicked/) == -1){
			$(this).removeClass('tab');
			$(this).addClass('tab-over');
		}
	});

	$('div.tab').mouseout(function(){

		if($(this).attr('class').search(/tab-clicked/) == -1){
			$(this).removeClass('tab-over');
			$(this).addClass('tab');
		}
	});
}

function stopIndicator(){
	$('div.tab-bar img[@src="images/indicator.gif"]').attr('src', 'images/tab-logo.gif');
}

function mainh_0(){
	$('div#mainh').html('&nbsp;');
}

function mainh_1(){
	$('div#mainh').html('<table width=100% cellpadding=0 cellspacing=0 height=24><tr><td width=12% align=left>Hits</td><td width=43%>Page</td><td width=45%>Page Url</td><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td></tr></table>');
}

function mainh_2(){
	$('div#mainh').html('<table width=100% cellpadding=0 cellspacing=0 height=24><tr><td width=40% align=left>Page</td><td width=40%>Entry Point</td><td width=20%>When</td><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td></tr></table>');
}

function mainh_3(){
	$('div#mainh').html('<table width=100% cellpadding=0 cellspacing=0 height=24><tr><td width=12% align=left>Hits</td><td width=43%>From</td><td width=45%>To</td><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td></tr></table>');
}

function mainh_4(){
	$('div#mainh').html('<table width=100% cellpadding=0 cellspacing=0 height=24><tr><td width=40% align=left>From</td><td width=40%>To</td><td width=20%>When</td><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td></tr></table>');
}

function mainh_5(){
	$('div#mainh').html('<table width=100% cellpadding=0 cellspacing=0 height=24><tr><td width=12% align=left>Hits</td><td width=43%>Keywords</td><td width=45%>Found</td><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td></tr></table>');
}

function mainh_6(){
	$('div#mainh').html('<table width=100% cellpadding=0 cellspacing=0 height=24><tr><td width=40% align=left>Keywords</td><td width=40%>Found</td><td width=20%>When</td><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td></tr></table>');
}